/* d_array.h
 *
 *  Copyright (C) 2006 Tuomo Makinen (tjam@users.sourceforge.net)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef D_ARRAY_H
#define D_ARRAY_H

#include <stdio.h>
#include <stdlib.h>

struct d_array
{
  struct member **element;
  unsigned int __size;
};

struct member
{
  void *payload;
};

struct d_array * d_array_create ();
int d_array_delete (struct d_array *array);
int d_array_add_element (struct d_array *array);
struct member * d_array_get_element (struct d_array *array, unsigned int index); 
unsigned int d_array_get_size (struct d_array *array);

#endif /* D_ARRAY_H */
