/* nuhesock.h
 *
 * Copyright (C) 2007 Tuomo Makinen (tjam@users.sourceforge.net)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef NUHESOCK_H
#define NUHESOCK_H

#include <openssl/bio.h>
#include <openssl/err.h>
#include <openssl/rand.h>
#include <openssl/ssl.h>
#include <openssl/x509v3.h>
#include "nuhed.h"

#define DBUFSZ 256

#define CRLF "\r\n"

#define CIPHERS "ALL:!ADH:!LOW:!EXP:!MD5:@STRENGTH"

#define int_error(msg)  handle_error(__FILE__, __LINE__, msg)

void handle_error (const char *file, int fileno, const char *msg);
int init_openssl (void);
SSL_CTX *create_ssl_context (char * certfile, char * pkeyfile,
                             char * cafile, char * cadir);
SSL * create_ssl_connection (SSL_CTX * ctx, char * hconn);
int read_sock (SSL * ssl, char ** buf);
int write_sock (SSL * ssl, char * msg);
int verify_cb (int ok, X509_STORE_CTX * store);
int seed_prng (int bytes);
long post_conn_check (SSL * ssl, char * host);

#endif /* NUHESOCK_H */
