/* slist.h
 *
 *  Copyright (C) 2006,2007 Tuomo Makinen (tjam@users.sourceforge.net)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef SLIST_H
#define SLIST_H

#include <stdio.h>
#include <stdlib.h>

struct list_s
{
  struct node *head;
  struct node *tail;
};

struct node
{
  struct node *next;
  void *payload;
};

struct list_s *slist_create ();
struct node *slist_push (struct list_s *list);
struct node *slist_append (struct list_s *list);
int slist_length (struct list_s *list);
void slist_clear (struct list_s *list);
void slist_delete (struct list_s *list);

#endif	/* SLIST_H */
