#!/bin/bash
#
# entry_web.sh
#
# description: entrypoint for web container
#
#

APP_PATH="/opt/nuhedman"
MGRBIN_PATH="$APP_PATH/lib/class/plugins/bmm_nuhe_manager/bin"
LOGDBIN_PATH="$APP_PATH/lib/class/plugins/bmm_log_manager/bin"

chown -R www-data $APP_PATH

# update container ip for dynamic ip
cat /etc/hosts | grep -v nuhedcontainer > /tmp/hosts
cat $APP_PATH/container_host.txt >> /tmp/hosts
cat /tmp/hosts > /etc/hosts

if [ ! -f $APP_PATH/initdone ];then
   rm -f /var/log/apache2/error.log
   touch /var/log/apache2/error.log
   chown www-data:www-data /var/log/apache2/error.log
fi

source /etc/apache2/envvars
service apache2 start

while [ 1 -eq 1 ]
do 
  if [ -f $APP_PATH/conf/config.conf ];then

    if [ ! -f $APP_PATH/initdone ];then
       $MGRBIN_PATH/bmm_nuhe_manager.py init
       $MGRBIN_PATH/bmm_log_manager.py node_sync
       touch $APP_PATH/initdone
    fi

    cd $MGRBIN_PATH
    $MGRBIN_PATH/bmm_nuhe_manager.py poll
    $MGRBIN_PATH/bmm_nuhe_manager.py blocked

    cd $LOGDBIN_PATH
    $LOGDBIN_PATH/bmm_log_manager.py node_sync
    $LOGDBIN_PATH/bmm_log_manager.py conf_sync
    $LOGDBIN_PATH/bmm_log_manager.py log_sync
    $LOGDBIN_PATH/bmm_log_manager.py log_upload

    echo $(date)" [WEB] Nodemgr data poll executed" >> /tmp/poll.log
  fi
  sleep 60
done

echo " !!!!! Entrpoint for web exited !!!!!"
exit 0
